mkdir -p dev.nbest.50
bin/lattice-tool.addpron2ac -nbest-decode 50 -read-htk -htk-logbase 2.718 -htk-lmscale 12.0  -htk-wdpenalty 0.0 -htk-prscale 12.0 -in-lattice-list dev.latlist -out-nbest-dir dev.nbest.50/
gunzip dev.nbest.50/*.gz
sed -i 's#\\##g' dev.nbest.50/*
ls dev.nbest.50/* > dev.nbestlist
 i=0; for file in `cat dev.nbestlist` ; do cat $file | awk -v i=$i '{printf "%d %s\n", i, $0}';  i=`expr $i + 1`; done > dev.nbest.info.txt
cat dev.nbest.info.txt | awk '{printf "%d", $1; for (i=6; i<NF; i++) printf " %s", $i; print ""}' > dev.nbest.txt
awk '{for (i=2;i<=NF;i++) printf $i " "; print "";}' dev.nbest.txt  > dev.text.txt
# need to add sentence boundaries here, to ensure the empty sentence could be calculated as well.
cat dev.text.txt | awk '{printf "<s> %s </s>\n", $0}' > dev.text.txt.withsentbound
ngram -order 3 -lm ../3glm/ami.o3g.kn.gz -ppl dev.text.txt.withsentbound -debug 2 > dev.ngram.scores.txt
cat dev.ngram.scores.txt | grep 'p(' | awk '{print $8}' > dev.ngram.word.scores

# for frnnlm
/home/mifs/xc257/rnnlm/RNNLM.cued/src.addnbest/rnnlm -nbest -readmodel ./frnnlm.txt -testfile ./dev.nbest.info.txt -inputwlist ../wlists/input.wlist.index -outputwlist ../wlists/output.wlist.index -debug 0 -fullvocsize 49413 -nglmstfile ./dev.ngram.word.scores -lambda 0.5  -nthread 8 >  dev.frnn.1best.rescored.rnn+ngram.txt
bin/genAlignmlf.pl dev.frnn.1best.rescored.rnn+ngram.txt dev.latlist dev.frnn.mlf
perl bin/converMlf2Txt.pl dev.frnn.mlf dev.frnn.txt

cd scoring/
./score.sh dev ../dev.frnn.txt
%WER 24.55 [ 23302 / 94914, 2793 ins, 6497 del, 14012 sub ]

# for crnnlm
/home/mifs/xc257/rnnlm/RNNLM.cued/src.addnbest/rnnlm -nbest -readmodel ./crnnlm.txt -testfile ./dev.nbest.info.txt -inputwlist ../wlists/input.wlist.index -outputwlist ../h200.mb64.lr1.0.c200/rnnlm.txt.output.wlist -debug 0 -fullvocsize 49413 -nglmstfile ./dev.ngram.word.scores -lambda 0.5  -nthread 8 > dev.crnn.1best.rescored.rnn+ngram.txt
bin/genAlignmlf.pl dev.crnn.1best.rescored.rnn+ngram.txt dev.latlist dev.crnn.mlf
perl bin/converMlf2Txt.pl dev.crnn.mlf dev.crnn.txt
cd scoring/
./score.sh dev ../dev.crnn.txt
%WER 24.90 [ 23630 / 94914, 2965 ins, 6378 del, 14287 sub ]

# for frnnlm+vr
/home/mifs/xc257/rnnlm/RNNLM.cued/src.addnbest/rnnlm -nbest -readmodel ./frnnlm+vr.txt -testfile ./dev.nbest.info.txt -inputwlist ../wlists/input.wlist.index -outputwlist ../wlists/output.wlist.index -debug 0 -fullvocsize 49413 -nglmstfile ./dev.ngram.word.scores -lambda 0.5  -nthread 8  -lognormconst 14.441 > dev.frnn+vr.1best.rescored.rnn+ngram.txt
bin/genAlignmlf.pl dev.frnn+vr.1best.rescored.rnn+ngram.txt dev.latlist dev.frnn+vr.mlf
perl bin/converMlf2Txt.pl dev.frnn+vr.mlf dev.frnn+vr.txt
cd scoring/
./score.sh dev ../dev.frnn+vr.txt
%WER 24.58 [ 23334 / 94914, 2793 ins, 6493 del, 14048 sub ]

#for frnnlm+nce
/home/mifs/xc257/rnnlm/RNNLM.cued/src.addnbest/rnnlm -nbest -readmodel ./frnnlm+nce.txt -testfile ./dev.nbest.info.txt -inputwlist ../wlists/1M.wlist.index -outputwlist ../wlists/1M.wlist.index -debug 0 -fullvocsize 49413 -nglmstfile ./dev.ngram.word.scores -lambda 0.5  -nthread 8  -lognormconst 9.0 > dev.frnn+nce.1best.rescored.rnn+ngram.txt
bin/genAlignmlf.pl dev.frnn+nce.1best.rescored.rnn+ngram.txt dev.latlist dev.frnn+nce.mlf
perl bin/converMlf2Txt.pl dev.frnn+nce.mlf dev.frnn+nce.txt
cd scoring/
./score.sh dev ../dev.frnn+nce.txt
%WER 24.56 [ 23308 / 94914, 2820 ins, 6493 del, 13995 sub ]

#for frnnlm+lda
perl bin/mapNbest2FeainfoFile.pl ../data.lda20/train+dev_lda.file dev.nbestlist dev.nbest.info.txt  > dev.nbest.info.txt.withtm
/home/mifs/xc257/rnnlm/RNNLM.cued/src.addnbest/rnnlm -nbest -readmodel ./frnnlm+lda20.txt -testfile ./dev.nbest.info.txt.withtm -inputwlist ../wlists/input.wlist.index -outputwlist ../wlists/output.wlist.index -debug 0 -fullvocsize 49413 -nglmstfile ./dev.ngram.word.scores -lambda 0.5  -nthread 8 -feafile ../data.lda20/ldainfo   &> dev.frnn+lda20.1best.rescored.rnn+ngram.txt 
bin/genAlignmlf.pl dev.frnn+lda20.1best.rescored.rnn+ngram.txt dev.latlist dev.frnn+lda20.mlf
perl bin/converMlf2Txt.pl dev.frnn+lda20.mlf dev.frnn+lda20.txt
cd scoring/
./score.sh dev ../dev.frnn+lda20.txt
%WER 24.22 [ 22991 / 94914, 2779 ins, 6466 del, 13746 sub ]





mkdir -p eval.nbest.50
./lattice-tool.addpron2ac -nbest-decode 50 -read-htk -htk-logbase 2.718 -htk-lmscale 12.0  -htk-wdpenalty 0.0 -htk-prscale 12.0 -in-lattice-list eval.latlist -out-nbest-dir eval.nbest.50/
gunzip eval.nbest.50/*.gz
sed -i 's#\\##g' eval.nbest.50/*
ls eval.nbest.50/* > eval.nbestlist
 i=0; for file in `cat eval.nbestlist` ; do cat $file | awk -v i=$i '{printf "%d %s\n", i, $0}';  i=`expr $i + 1`; done > eval.nbest.info.txt
cat eval.nbest.info.txt | awk '{printf "%d", $1; for (i=6; i<NF; i++) printf " %s", $i; print ""}' > eval.nbest.txt
awk '{for (i=2;i<=NF;i++) printf $i " "; print "";}' eval.nbest.txt  > eval.text.txt
# need to add sentence boundaries here, to ensure the empty sentence could be calculated as well.
cat eval.text.txt | awk '{printf "<s> %s </s>\n", $0}' > eval.text.txt.withsentbound
ngram -order 3 -lm ../3glm/ami.o3g.kn.gz -ppl eval.text.txt.withsentbound -debug 2 > eval.ngram.scores.txt
cat eval.ngram.scores.txt | grep 'p(' | awk '{print $8}' > eval.ngram.word.scores

# for frnnlm
 /home/mifs/xc257/rnnlm/RNNLM.cued/src.addnbest/rnnlm -nbest -readmodel ./frnnlm.txt -testfile ./eval.nbest.info.txt -inputwlist ../wlists/input.wlist.index -outputwlist ../wlists/output.wlist.index -debug 0 -fullvocsize 49413 -nglmstfile ./eval.ngram.word.scores -lambda 0.5  -nthread 8 >  eval.frnn.1best.rescored.rnn+ngram.txt
bin/genAlignmlf.pl eval.frnn.1best.rescored.rnn+ngram.txt eval.latlist eval.frnn.mlf
perl bin/converMlf2Txt.pl eval.frnn.mlf eval.frnn.txt
cd scoring/
./score.sh eval ../eval.frnn.txt
%WER 24.68 [ 22126 / 89635, 2236 ins, 5603 del, 14287 sub ]

# for crnnlm
/home/mifs/xc257/rnnlm/RNNLM.cued/src.addnbest/rnnlm -nbest -readmodel ./crnnlm.txt -testfile ./eval.nbest.info.txt -inputwlist ../wlists/input.wlist.index -outputwlist ../h200.mb64.lr1.0.c200/rnnlm.txt.output.wlist -debug 0 -fullvocsize 49413 -nglmstfile ./eval.ngram.word.scores -lambda 0.5  -nthread 8 > eval.crnn.1best.rescored.rnn+ngram.txt
bin/genAlignmlf.pl eval.crnn.1best.rescored.rnn+ngram.txt eval.latlist eval.crnn.mlf
perl bin/converMlf2Txt.pl eval.crnn.mlf eval.crnn.txt
cd scoring/
./score.sh eval ../eval.crnn.txt
%WER 24.99 [ 22397 / 89635, 2369 ins, 5455 del, 14573 sub ]

# for frnnlm+vr
/home/mifs/xc257/rnnlm/RNNLM.cued/src.addnbest/rnnlm -nbest -readmodel ./frnnlm+vr.txt -testfile ./eval.nbest.info.txt -inputwlist ../wlists/input.wlist.index -outputwlist ../wlists/output.wlist.index -debug 0 -fullvocsize 49413 -nglmstfile ./eval.ngram.word.scores -lambda 0.5  -nthread 8  -lognormconst 14.441 > eval.frnn+vr.1best.rescored.rnn+ngram.txt
bin/genAlignmlf.pl eval.frnn+vr.1best.rescored.rnn+ngram.txt eval.latlist eval.frnn+vr.mlf
perl bin/converMlf2Txt.pl eval.frnn+vr.mlf eval.frnn+vr.txt
cd scoring/
./score.sh eval ../eval.frnn+vr.txt
%WER 24.61 [ 22060 / 89635, 2284 ins, 5558 del, 14218 sub ]

#for frnnlm+nce
/home/mifs/xc257/rnnlm/RNNLM.cued/src.addnbest/rnnlm -nbest -readmodel ./frnnlm+nce.txt -testfile ./eval.nbest.info.txt -inputwlist ../wlists/1M.wlist.index -outputwlist ../wlists/1M.wlist.index -debug 0 -fullvocsize 49413 -nglmstfile ./eval.ngram.word.scores -lambda 0.5  -nthread 8  -lognormconst 9.0 > eval.frnn+nce.1best.rescored.rnn+ngram.txt
bin/genAlignmlf.pl eval.frnn+nce.1best.rescored.rnn+ngram.txt eval.latlist eval.frnn+nce.mlf
perl bin/converMlf2Txt.pl eval.frnn+nce.mlf eval.frnn+nce.txt
cd scoring/
./score.sh eval ../eval.frnn+nce.txt
%WER 24.57 [ 22027 / 89635, 2251 ins, 5581 del, 14195 sub ]

#for frnnlm+lda
perl bin/mapNbest2FeainfoFile.pl ../data.lda20/eval_lda.file eval.nbestlist eval.nbest.info.txt  > eval.nbest.info.txt.withtm
/home/mifs/xc257/rnnlm/RNNLM.cued/src.addnbest/rnnlm -nbest -readmodel ./frnnlm+lda20.txt -testfile ./eval.nbest.info.txt.withtm -inputwlist ../wlists/input.wlist.index -outputwlist ../wlists/output.wlist.index -debug 0 -fullvocsize 49413 -nglmstfile ./eval.ngram.word.scores -lambda 0.5  -nthread 8 -feafile ../data.lda20/ldainfo.eval   &> eval.frnn+lda20.1best.rescored.rnn+ngram.txt 
bin/genAlignmlf.pl eval.frnn+lda20.1best.rescored.rnn+ngram.txt eval.latlist eval.frnn+lda20.mlf
perl bin/converMlf2Txt.pl eval.frnn+lda20.mlf eval.frnn+lda20.txt
cd scoring/
./score.sh eval ../eval.frnn+lda20.txt
%WER 24.26 [ 21746 / 89635, 2249 ins, 5544 del, 13953 sub ]
